#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;

const int mod = 1e9 + 7;

int main()
{
    ll n, k;
    cin >> n >> k;
    if (n == k)
    {
        cout << "1";
        return 0;
    }
    vector<vector<vector<int> > > dp0(n, vector<vector<int> > (n + 1, vector<int> (n + 1, 0)));
    vector<vector<vector<int> > > dp1(n, vector<vector<int> > (n + 1, vector<int> (n + 1, 0)));
    //vector<vector<vector<ll> > > dp(n, vector<vector<ll> > (n + 1, vector<ll> (n + 1, 0)));
    dp0[0][k][k] = 1;
    dp1[0][k][k] = 1;
    //dp[0][k][k] = 1;
    ll sum = 0;
    for (int i = 1; i < n; i++)
    {
        for (int s = k; s <= n; s++)
        {
            for (int x = 1; x <= s; x++)
            {
                if (x == 1)
                {
                    dp0[i][s][1] = 0;
                   /* for (int t = 1; t <= x - 1; t++)
                     {
                         dp0[i][s][x] += dp1[i - 1][s - x][t];
                     }*/
                    for (int t = 2; t <= s; t++)
                    {
                        dp1[i][s][1] += dp0[i - 1][s - 1][t];
                        dp1[i][s][1] %= mod;
                    }
                }
                else
                {
                    ll a = dp0[i][s - 1][x - 1] + dp1[i - 1][s - x][x - 1];
                    ll b = dp1[i][s - 1][x - 1] - dp0[i - 1][s - x][x];
                    /*for (int t = 1; t <= x - 1; t++)
                    {
                        dp0[i][s][x] += dp1[i - 1][s - x][t];
                    }
                    for (int t = x + 1; t <= s; t++)
                    {
                        dp1[i][s][x] += dp0[i - 1][s - x][t];
                    }*/
                    dp0[i][s][x] = a;
                    dp1[i][s][x] = b;
                }
                dp0[i][s][x] %= mod;
                dp1[i][s][x] %= mod;
            }
            sum = 0;
            for (int t = 2; t <= s; t++)
            {
                sum += dp0[i - 1][s][t];
            }
        }
    }

    int ans = 0;

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j <= n; j++)
        {
            ans += dp0[i][n][j] + dp1[i][n][j];
            ans %= mod;
        }
    }
    cout << ans;
}
