#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

typedef long long ll;

vector<set<ll> > g1;
vector<vector<ll> > g;
/**
4 2 4 2 1

3 2 -1 2

6
2 3 1 2 6 5

7
2 3 4 1 2 5 5

7
2 4 1 -1 2 3 3

13
2 3 1 5 6 7 8 -1 1 3 3 10 10

*/

vector<ll> c;

vector<bool> used;

int V = -1;

bool dfs(ll v, ll pr = -1)
{
    used[v] = true;
    if (V == -1)
        c.push_back(v);
    for (int i = 0; i < g[v].size(); i++)
    {
        ll to = g[v][i];
        if (to == pr)
        {
            if (g1[v].find(to) != g1[v].end() && g1[to].find(v) != g1[to].end())
            {
                if (V == -1)
                {
                    V = to;
                }
            }
        }
        else
        {
            if (used[to])
            {
                if (V == -1)
                {
                    V = to;
                }
            }
        }
    }
    for (int i = 0; i < g[v].size(); i++)
    {
        ll to = g[v][i];
        if (to == pr)
        {

        }
        else
        {
            if (used[to])
            {
            }
            else
            {
                dfs(to, v);
            }
        }
    }
    if (V == -1)
        return false;
    return true;
}

vector<bool> inc;

vector<vector<ll> > dp;

void f(ll v, ll pr = -1)
{
    for (int i = 0; i < g[v].size(); i++)
    {
        ll to = g[v][i];
        if (to == pr)
            continue;
        if (inc[to])
            continue;
        f(to, v);
    }
    ll s = 0;
    for (int i = 0; i < g[v].size(); i++)
    {
        ll to = g[v][i];
        if (to == pr)
            continue;
        if (inc[to])
            continue;
        s += max(dp[to][0], dp[to][1]);
    }
    dp[v][0] = s;
    s = 0;
    for (int i = 0; i < g[v].size(); i++)
    {
        ll to = g[v][i];
            if (to == pr)
            continue;
        if (inc[to])
            continue;
        s += dp[to][0];
    }
    dp[v][1] = s + 1;
}

void f1(ll v, ll pr = -1)
{
    used[v] = true;
    for (int i = 0; i < g[v].size(); i++)
    {
        ll to = g[v][i];
        if (to == pr)
            continue;
        if (inc[to])
            continue;
        f1(to, v);
    }
    ll s = 0;
    for (int i = 0; i < g[v].size(); i++)
    {
        ll to = g[v][i];
        if (to == pr)
            continue;
        if (inc[to])
            continue;
        s += max(dp[to][0], dp[to][1]);
    }
    dp[v][0] = s;
    s = 0;
    for (int i = 0; i < g[v].size(); i++)
    {
        ll to = g[v][i];
            if (to == pr)
            continue;
        if (inc[to])
            continue;
        s += dp[to][0];
    }
    dp[v][1] = s + 1;
}


int main()
{
    ll n;
    cin >> n;
    g1.resize(n);
    g.resize(n);
    used.resize(n, false);
    for (int i = 0; i < n; i++)
    {
        ll x;
        cin >> x;
        if (x == -1)
            continue;
        x--;
        g1[i].insert(x);
        g[i].push_back(x);
        g[x].push_back(i);
    }
    vector<vector<ll> > cic;

    inc.resize(n, false);

    for (int i = 0; i < n; i++)
    {
        V = -1;
        c.clear();
        if (!used[i])
        {
            dfs(i);
            if (V == -1)
                continue;
            reverse(c.begin(), c.end());
            while (c.back() != V)
                c.pop_back();
            if (c.size() != 0)
                cic.push_back(c);
            for (int i = 0; i < c.size(); i++)
            {
                inc[c[i]] = true;
            }
        }
    }
    used.clear();
    used.resize(n, false);

    vector<ll> k1(n, 0);
    vector<ll> k2(n, 0);

    for (int i = 0; i < cic.size(); i++)
    {
        for (int j = 0; j < cic[i].size(); j++)
        {
            ll v = cic[i][j];
            dp.clear();
            dp.resize(n, vector<ll> (2, 0));
            f1(v);
            k1[v] = dp[v][0];
            k2[v] = dp[v][1];
        }
    }

    ll A = 0;

    for (int i = 0; i < cic.size(); i++)
    {
        if (cic[i].size() == 2)
        {
            ll ans = max(k1[cic[i][0]] + k2[cic[i][1]], k1[cic[i][1]] + k2[cic[i][0]]);
            A += ans;
            continue;
        }
        vector<ll> x = cic[i];
        x.pop_back();
        ll n1 = x.size();
        vector<vector<ll> > dp0(n1, vector<ll> (2, 0));
        dp0[0][0] = k1[x[0]];
        dp0[0][1] = k2[x[0]];
        for (int j = 1; j < n1; j++)
        {
            dp0[j][0] = k1[x[j]] + max(dp0[j - 1][0], dp0[j - 1][1]);
            dp0[j][1] = k2[x[j]] + dp0[j - 1][0];
        }
        ll ans0 = k1[cic[i].back()] + max(dp0[n1 - 1][0], dp0[n1 - 1][1]);
        x.clear();
        x = cic[i];
        x.pop_back();
        x.pop_back();
        reverse(x.begin(), x.end());
        x.pop_back();
        ll ans1 = k1[cic[i][0]] + k1[cic[i][cic[i].size() - 2]] + k2[cic[i].back()];
        n1 = x.size();
        vector<vector<ll> > dp1(n1, vector<ll> (2, 0));
        if (n1 > 0)
        {
            dp1[0][0] = k1[x[0]];
            dp1[0][1] = k2[x[0]];
            for (int j = 1; j < n1; j++)
            {
                dp1[j][0] = k1[x[j]] + max(dp1[j - 1][0], dp1[j - 1][1]);
                dp1[j][1] = k2[x[j]] + dp1[j - 1][0];
            }
            ans1 += max(dp1[n1 - 1][0], dp1[n1 - 1][1]);
        }
        A += max(ans0, ans1);
    }
    for (int i = 0; i < n; i++)
    {
        if (used[i])
            continue;
        dp.clear();
        dp.resize(n, vector<ll> (2, 0));
        f1(i);
        A += max(dp[i][0], dp[i][1]);
    }
    cout << A;
}
