#include <iostream>
#include <cmath>

using namespace std;

typedef long long ll;

int main()
{
    ll k;
    cin >> k;
    bool otr = false;
    if (k < 0)
    {
        otr = true;
        k = -k;
    }
    if (k == 0)
    {
        cout << "0";
        return 0;
    }
    for (ll i = 1; i * i <= k; i++)
    {
        if (k % i != 0)
            continue;
        ll x1 = i;
        ll x2 = k / i;
        if (x1 > x2)
            swap(x1, x2);
        if ((x1 + x2) % 2 == 0)
        {
            ll a = (x1 + x2) / 2;
            ll i1 = (x2 - x1) / 2;
            if (otr && a - i1 > 0)
                swap(a, i1);
            cout << a;
            return 0;
        }
    }
    cout << "none";
    return 0;

    /*vector<pair<ll, ll> > A;
    ll k1 = k;
    for (ll i = 2; i * i <= k; i++)
    {
        ll kol = 0;
        while (k1 % i == 0)
        {
            kol++;
            k1 /= i;
        }
        if (kol == 0)
            continue;
        A.push_back({i, kol});
    }
    if (k1 != 1)
        A.push_back({k1, 1});


*/

}
