#include <iostream>
#include <cmath>

using namespace std;

typedef long long ll;

ll sl1(ll k)
{
    for (ll i = 0; i < 3e6; i++)
    {
        ll x = k + i * i;
        if (x < 0)
            continue;
        if (ll(sqrt(x)) * ll(sqrt(x)) == x)
        {
            return ll(sqrt(x));
        }
    }
    return -1;
}

ll sla(ll k)
{
    bool otr = false;
    if (k < 0)
    {
        otr = true;
        k = -k;
    }
    if (k == 0)
    {
        return 0;
    }
    ll ans = 1e15;
    for (ll i = 1; i * i <= k; i++)
    {
        if (k % i != 0)
            continue;
        ll x1 = i;
        ll x2 = k / i;
        if (x1 > x2)
            swap(x1, x2);
        if ((x1 + x2) % 2 == 0)
        {
            ll a = (x1 + x2) / 2;
            ll i1 = (x2 - x1) / 2;
            if (otr && a - i1 > 0)
                swap(a, i1);
            ans = min(ans, a);
            //return a;
        }
    }
    if (ans == 1e15)
    return -1;
    return ans;
}

int main()
{
    ll k;
    cin >> k;
    bool otr = false;
    ll x = sla(k);
    if (x == -1)
        cout << "none";
    else
        cout << x;
}
