#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

vector<ll> A;
vector<vector<ll> > B;
vector<ll> B1;
vector<ll> B2;
ll n, m;
/*
3 5
2 3 2 1 2
1 2 3
*/

bool comp(vector<ll> a, vector<ll> b)
{
    if (a.size() == 0)
        return false;
    if (b.size() == 0)
        return true;
    if (a.back() < b.back())
        return true;
    return false;
}

bool comp1(pair<vector<ll>, int> a, pair<vector<ll>, int> b)
{
    if (a.first.size() == 0)
        return false;
    if (b.first.size() == 0)
        return true;
    if (a.first.back() < b.first.back())
        return true;
    return false;
}

/*
4 5
4 1 2 4 4
4 3 2 1
*/
int main()
{
    cin >> n >> m;
    A.resize(m);
    B1.resize(n);
    B.resize(n);
    set<pair<ll, ll> > S;
    vector<ll> kol(n, 0);
    for (int i = 0; i < m; i++)
    {
        cin >> A[i];
        A[i]--;
        kol[A[i]]++;
        pair<ll, ll> p1(A[i], i);
        S.insert(p1);
    }
    for (int i = 0; i < n; i++)
    {
        cin >> B1[i];
        B1[i]--;
    }

    for (int i = 0; i < B1.size(); i++)
    {
        for (int j = 0; j < kol[B1[i]]; j++)
        {
            ll x = B1[i];
            pair<ll, ll> p1(x, -1);
            set<pair<ll, ll> > :: iterator it = S.lower_bound(p1);
            ll pr = 1e10;
            if (it != S.end())
            {
                pr = (*it).second;
                S.erase(it);
            }
            B[i].push_back(pr);
        }
        B[i].push_back(1e10 + i);
        reverse(B[i].begin(), B[i].end());
    }
    /*cout << "pr : \n";
    for (int i = 0; i < B.size(); i++)
    {
        cout << "i : ";
        for (int j = 0; j < B[i].size(); j++)
        {
            cout << B[i][j] << " ";
        }
        cout << "\n";
    }
    cout << "\n\n";
    cout << "-------------\n";*/

    ll ans = 0;
    vector<ll> PO;
    for (int pr = 0; pr < m; pr++)
    {
        int pos = 0;
        while (B[pos].back() != pr)
            pos++;
        B[pos].pop_back();
        /* cout << "pr : \n";
         for (int i = 0; i < B.size(); i++)
         {
             cout << i << " : ";
             for (int j = 0; j < B[i].size(); j++)
             {
                 cout << B[i][j] << " ";
             }
             cout << "\n";
         }
         cout << "\n\n";
         cout << "prior = " << pr << endl;
        //cout << "i = " << i << endl;*/
         //cout << "pos = " << pos << endl;
        ans += pos + 1;
       /* if (pos == B.size() - 1)
        {
            cout << "conti\n\n";
            B.back().pop_back();
            vector<pair<vector<ll>, int> > B3(B.size());
            for (int i = 0; i < B3.size(); i++)
            {
                B3[i].first = B[i];
                B3[i].second = i;
            }
            sort(B3.begin(), B3.end(), comp1);
            vector<ll> oper(B3.size());
            for (int i = 0; i < B3.size(); i++)
            {
                cout << "B3[" << i << "] = " << B3[i].second + 1 << endl;
                oper[B3[i].second] = i;
            }
            cout << "oper: ";
            for (int i = 0; i <= pos; i++)
            {
                cout << oper[i] + 1 << " ";
                PO.push_back(oper[i] + 1);
            }
            cout << "\n";

            sort(B.begin(), B.end(), comp);
            continue;
        }*/
        vector<pair<vector<ll>, int> > B3(B.size());
        for (int i = 0; i < B3.size(); i++)
        {
            B3[i].first = B[i];
            B3[i].second = i;
        }
        sort(B3.begin(), B3.begin() + pos + 1, &comp1);
        sort(B.begin(), B.begin() + pos + 1, &comp);

        vector<ll> to(pos + 1, -1);/// to[i] :   i

        ll ykb = pos;
        ll ykto = B.size() - 1;

        while (true)
        {
            //cout << "t";
            if (ykto < pos - 1 || ykb < 0)
                break;
            //cout << B[ykb].back() << " " << B[ykto].back() << endl;
            if (B[ykb].back() < B[ykto].back())
            {
                ykto--;
                continue;
            }
            if (B[ykb].back() >= B[ykto].back())
            {
                to[ykb] = ykto - pos - 1;
                ykb--;
                continue;
            }
        }
        //cout << "end";
        vector<vector<ll> > B2;
        vector<pair<vector<ll>, int> > B4;

        ykb = 0;
        if (ykto < 0)
        {
            to[0] = -1;
            B2.push_back(B[0]);
            B4.push_back(B3[0]);
            ykb++;
        }
        else if (to[0] == -1)
        {
            B2.push_back(B[0]);
            B4.push_back(B3[0]);
            ykb = 1;
        }

        ll ykb1 = pos + 1;
        ll i = 0;
         /*for (int i = 0; i < to.size(); i++)
         {
             cout << "to[" << i << "] = " << to[i] << endl;
         }
         cout << "        bac = " << B[0].back() << endl;*/

        //cout << "ok"; return 0;
        while (true)
        {
            //cout << "T";
            if ((ykb >= pos + 1 && ykb1 >= B.size()) || i > B.size())
                break;
            //cout << "i = " << i << endl;
            //cout << "ykb = " << ykb << "  ykb1 = " << ykb1 << endl;

            if (to[ykb] == ykb1 - pos - 2)
            {
                //B2.push_back(B[ykb1]);
                B2.push_back(B[ykb]);
                B4.push_back(B3[ykb]);
                ykb++;
                i++;
                continue;
            }
            if (ykb1 < B.size())
            {

            B2.push_back(B[ykb1]);
            B4.push_back(B3[ykb1]);
            ykb1++;
            }
            i++;
        }
        // cout << "er" << endl;

        if (ykb1 >= B.size() && ykb < pos)
        {
            for (int i = ykb; i <= pos; i++)
            {
                B2.push_back(B[i]);
                B4.push_back(B3[i]);
            }
        }
        B = B2;

        vector<ll> oper(B.size());
        for (int i = 0; i < B4.size(); i++)
        {
            oper[B4[i].second] = i;
        }

        for (int i = 0; i <= pos; i++)
        {
            //cout << oper[i] + 1 << " ";
            PO.push_back(oper[i] + 1);
        }
        //cout << "\n\n";

        /* cout << "pr : \n";
         for (int i = 0; i < B.size(); i++)
         {
             cout << i << " : ";
             for (int j = 0; j < B[i].size(); j++)
             {
                 cout << B[i][j] << " ";
             }
             cout << "\n";
         }
         cout << "\n\n";
         cout << "\n\n\n\n\n\n";*/
        // exit(0);

    }
    cout << ans << endl;
    for (int i = 0; i < PO.size(); i++)
    {
        cout << PO[i] << " ";
    }
}
