#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

const ll mod = 1e9 + 7;

bool is(ll ai, ll aj)
{
    if ((ai & aj) == ai)
        return true;
    return false;
}

int main()
{
    ll n, m, k;
    cin >> n >> m >> k;

    vector<vector<ll> > dp(n, vector<ll> (k + 1, 0));
    for (int i = 0; i <= k; i++)
    {
        dp[0][i] = 1;
       // cout << "dp[" << 0 << "][" << i << "] = " << dp[0][i] << endl;
    }

    for (int i = 1; i < n; i++)
    {
        for (int j = 0; j <= k; j++)
        {
            for (int f = 0; f <= k; f++)
            {
                if (is(f, j))
                {
                    dp[i][j] += dp[i - 1][f];
                    dp[i][j] %= mod;
                }
            }
        }
    }
   /* for (int i = 0; i < n; i++)
    {
        for (int j = 0; j <= k; j++)
        {
            cout << "dp[" << i << "][" << j << "] = " << dp[i][j] << endl;
        }
        cout << "\n";
    }*/
    //cout << "ok"; return 0;
    ll ans = 0;
    for (int i = 0; i <= k; i++)
    {
        ans += dp[n - 1][i];
        ans %= mod;
    }
    cout << ans;
}
