#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;

const int mod = 1e9 + 7;

const int N = 400;

int dp0[N][N + 1][N + 1];
int dp1[N][N + 1][N + 1];

int main()
{
    int n, k;
    cin >> n >> k;
    if (n == k)
    {
        cout << "1";
        return 0;
    }
    //vector<vector<vector<int> > > dp0(n, vector<vector<int> > (n + 1, vector<int> (n + 1, 0)));
    //vector<vector<vector<int> > > dp1(n, vector<vector<int> > (n + 1, vector<int> (n + 1, 0)));

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j <= n; j++)
        {
            for (int z = 0; z <= n; z++)
            {
                dp0[i][j][z] = 0;
                dp1[i][j][z] = 0;
            }
        }
    }
    dp0[0][k][k] = 1;
    dp1[0][k][k] = 1;
    for (int i = 1; i < n; i++)
    {
        ll s = 0;
        for (int s = k; s <= n; s++)
        {
            for (int x = 1; x <= s; x++)
            {
                if (x == 1)
                {
                    dp0[i][s][1] = 0;
                    for (int t = 2; t <= s; t++)
                    {
                        dp1[i][s][1] += dp0[i - 1][s - 1][t];
                        if (dp1[i][s][1] >= mod)
                        dp1[i][s][1] %= mod;
                    }
                }
                else
                {
                    int a = dp0[i][s - 1][x - 1] + dp1[i - 1][s - x][x - 1];
                    int b = dp1[i][s - 1][x - 1] - dp0[i - 1][s - x][x];
                    b %= mod;
                    while (b < 0)
                        b += mod;
                    dp0[i][s][x] = a;
                    dp1[i][s][x] = b;
                }
                if (dp0[i][s][x] >= mod)
                    dp0[i][s][x] %= mod;
                if (dp1[i][s][x] >= mod)
                    dp1[i][s][x] %= mod;
            }
        }

        for (int t = 0; t <= n; t++)
            s += dp0[i][n][t] + dp1[i][n][t];

        if (s == 0)
            break;

    }

    int ans = 0;

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j <= n; j++)
        {
            ans += dp0[i][n][j];
            if (ans >= mod)
            ans %= mod;
            ans += dp1[i][n][j];
            if (ans >= mod)
            ans %= mod;
        }
    }

    for (int i = 0; i < n; i++)
    {
        ll s = 0;
        for (int t = 0; t <= n; t++)
            s += dp0[i][n][t] + dp1[i][n][t];
        //cout << "dp[" << i << "] = " << s << endl;
    }

    cout << ans;
}
