#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;

const int mod = 1e9 + 7;

int main()
{
    int n, k;
    cin >> n >> k;
   /* if (n == k)
    {
        cout << "1";
        return 0;
    }*/
    vector<vector<vector<int> > > dp0(n, vector<vector<int> > (n + 1, vector<int> (n + 1, 0)));
    vector<vector<vector<int> > > dp1(n, vector<vector<int> > (n + 1, vector<int> (n + 1, 0)));
    vector<vector<vector<int> > > dp(n, vector<vector<int> > (n + 1, vector<int> (n + 1, 0)));
    dp0[0][k][k] = 1;
    dp1[0][k][k] = 1;
    dp[0][k][k] = 1;

    for (int i = 1; i < n; i++)
    {
        for (int s = k; s <= n; s++)
        {
            for (int x = 1; x <= s; x++)
            {
                for (int t = 1; t <= s; t++)
                {
                    dp[i][s][x] += dp[i - 1][s - x][t];
                    dp[i][s][x] %= mod;
                }
                dp[i][s][x] -= dp[i - 1][s - x][x];
                dp[i][s][x] %= mod;
                while (dp[i][s][x] < 0)
                    dp[i][s][x] += mod;
                /*for (int t = 1; t <= x - 1; t++)
                {
                    dp0[i][s][x] += dp1[i - 1][s - x][t];
                }
                for (int t = x + 1; t <= s; t++)
                {
                    dp1[i][s][x] += dp0[i - 1][s - x][t];
                }*/
                dp0[i][s][x] %= mod;
                dp1[i][s][x] %= mod;
                //dp[i][s][x] %= mod;
            }
        }
    }

    int ans = 0;

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j <= n; j++)
        {
            //ans += dp0[i][n][j] + dp1[i][n][j];
            ans += dp[i][n][j];
            ans %= mod;
        }
    }
    cout << ans;
}
